<?php 
if(strlen(session_id()) < 1)
session_start();
require_once('../modelos/Ingreso.php');

$ingreso=new Ingreso();

$idingreso=isset($_POST["idingreso"])? limpiarCadena($_POST["idingreso"]):"";
$idproveedor=isset($_POST["idproveedor"])? limpiarCadena($_POST["idproveedor"]):"";
$tipo_comprobante=isset($_POST["tipo_comprobante"])? limpiarCadena($_POST["tipo_comprobante"]):"";
$serie_comprobante=isset($_POST["serie_comprobante"])? limpiarCadena($_POST["serie_comprobante"]):"";
$numero_comprobante=isset($_POST["numero_comprobante"])? limpiarCadena($_POST["numero_comprobante"]):"";
$fecha_hora=isset($_POST["fecha_hora"])? limpiarCadena($_POST["fecha_hora"]):"";
$total_compra=isset($_POST["total_compra"])? limpiarCadena($_POST["total_compra"]):"";
$idusuario=$_SESSION["idusuario"];
$nrorecibo=$serie_comprobante."-".$numero_comprobante;
$estado='Aceptado';

switch ($_GET["op"])
{
    case 'guardaryeditar':
      if(empty($idingreso))
      {
        $rspta=$ingreso->insertar($idproveedor,$idusuario,$tipo_comprobante,$serie_comprobante,$numero_comprobante,$fecha_hora,$total_compra,$nrorecibo,$_POST["idarticulo"],$_POST["nroproducto"],$_POST["marca"],$_POST["cantidad"],$_POST["precio_compra"],$_POST["precio_venta"],$_POST["garantia"],$_POST["idarticuloCant"],$_POST["codigoCant"],$_POST["cantidadCant"],$_POST["macCant"],$_POST["serieCant"]);
        echo $rspta ? "Compra Registrado" : "Compra no se pudo registrar";
      }
      else {
          $rspta=$ingreso->editar($idingreso,$idproveedor,$tipo_comprobante,$serie_comprobante,$numero_comprobante,$fecha_hora);
          echo $rspta ? "Compra Actualizada" : "Compra no se pudo actualizar";
      }
    break;

    case 'mostrardetalle':
      $idingreso = isset($_GET['id']) ? intval($_GET['id']) : 0;
      $rspta = $ingreso->mostrardetalle($idingreso);
      echo json_encode($rspta);
  break;

    case 'mostrar':
      $rspta=$ingreso->mostrar($idingreso);
       //Codificar el resultado utilizando json
       echo json_encode($rspta);
    break;

    case 'eliminar':
      $rspta=$ingreso->eliminar($idingreso);
       //Codificar el resultado utilizando json
       echo json_encode($rspta);
    break;

    case 'validarRegistro':
      $valor = $_POST['valor'];
      $rspta=$ingreso->validarRegistro($valor);
       //Codificar el resultado utilizando json
       echo json_encode($rspta);
    break;

    case 'listaringreso':
      $rspta=$ingreso->listaringreso();
      //Vamos a declarar un array
      $data=Array();
      while($reg=$rspta->fetch_object())
      {
        $estado = ($reg->estado == 'Aceptado') 
            ? '<button class="btn btn-success btn-xs btn-flat">Aceptado</button>' 
            : '<button class="btn btn-danger btn-xs btn-flat">Anulado</button>';

            $estado_ingreso = ($reg->estado_ingreso == '1') 
            ? '<button class="btn btn-primary btn-xs btn-flat">Ingreso</button>' 
            : '<button class="btn btn-danger btn-xs btn-flat">Retorno</button>';

        $data[]=array(
          "0"=>$reg->fecha,
          "1"=>$reg->proveedor,
          "2"=>$reg->usuario,
          "3"=>$reg->tipo_comprobante,
          "4"=>$reg->serie_comprobante.'-'.$reg->num_comprobante, 
          "5"=>$reg->total_compra,          
          "6"=>$estado,
          "7"=>$estado_ingreso,
          "8"=>'<button class="btn btn-warning  btn-xs btn-flat open-AddImgDialog" onclick="mostrardetalle(' . $reg->idingreso . ')" data-toggle="modal" data-target="#modalProducto" ><i class="fa fa-folder-open"></i></button>' .
             ' <button class="btn btn-danger btn-xs btn-flat" onclick="eliminar(' . $reg->idingreso . ')"><i class="fas fa-trash-alt"></i></button>'
        );
      }
      $results= array(
        "sEcho"=>1, //Informacion para el datatable
        "iTotalRecords"=>count($data),//Enviamos el total de registtros en el datatable
        "iTotalDisplayRecords"=>count($data),//enviamos el total de registros a visualizar
        "aaData"=>$data);
      echo json_encode($results);

    break;

    case 'listarArticulos':
      require_once "../modelos/Producto.php";
      $producto = new Producto();
      $rspta = $producto->listarArticulos();
      
      $data = [];
      while ($reg = $rspta->fetch_object()) {
          $data[] = [
              "0" => $reg->nombre,
              "1" => $reg->categoria,
              "2" => $reg->codigo,       
              "3" => $reg->afectacion,
              "4" => '<button class="btn btn-success btn-xs btn-flat" onclick="agregarDetalle(' . $reg->idarticulo . ', \'' . $reg->codigo . '\', \'' . $reg->nombre . '\' ,\'' . $reg->nroproducto . '\', this)" data-id="'.$reg->idarticulo.'"><span class="fa fa-plus"></span></button>'
          ];
      }
      echo json_encode([
          "sEcho" => 1, 
          "iTotalRecords" => count($data), 
          "iTotalDisplayRecords" => count($data),
          "aaData" => $data
      ]);
      break;
}
?>